package gov.va.med.mhv.admin.converter;

import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.api.dto.PatientRegistryChangeDTO;
import gov.va.med.mhv.common.data.model.PatientRegistryChange;

@Component
public class PatientRegistryChangeLocalConverter {

	//TODO: Geetha - Remove this local file (PatientRegistryChangeLocalConverter) and use the one from mhv_common_api

	//@Autowired
	//private PatientLocalConverter patientConverter;

	public PatientRegistryChangeDTO convertDomainPatientRegistryChange(PatientRegistryChange patientRegistryChange) {
		PatientRegistryChangeDTO patientRegistryChangeDto = new PatientRegistryChangeDTO();

		patientRegistryChangeDto.setId(patientRegistryChange.getId());
		patientRegistryChangeDto.setOplock(patientRegistryChange.getOplock());
		patientRegistryChangeDto.setOldFacilityCount(patientRegistryChange.getOldFacilityCount());
		patientRegistryChangeDto.setOldIcn(patientRegistryChange.getOldIcn());
		patientRegistryChangeDto.setPatientId(patientRegistryChange.getPatientId());


		//ignored to add to patient details, as response json becoming too large
		/*if (null != patientRegistryChange.getPatient()) {
			patientRegistryChangeDto.setPatient(new PatientLocalConverter().convertDomainPatient(patientRegistryChange.getPatient()));
		}*/

		patientRegistryChangeDto.setRecordedOnDate(patientRegistryChange.getRecordedOnDate());
		patientRegistryChangeDto.setOldFirstName(patientRegistryChange.getOldFirstName());
		patientRegistryChangeDto.setOldBirthDate(patientRegistryChange.getOldBirthDate());
		patientRegistryChangeDto.setOldIcn(patientRegistryChange.getOldIcn());
		patientRegistryChangeDto.setOldGender(patientRegistryChange.getOldGender());
		patientRegistryChangeDto.setOldMiddleName(patientRegistryChange.getOldMiddleName());
		patientRegistryChangeDto.setOldNamePrefix(patientRegistryChange.getOldNamePrefix());
		patientRegistryChangeDto.setOldNameSuffix(patientRegistryChange.getOldNameSuffix());
		patientRegistryChangeDto.setOldAddressStreet1(patientRegistryChange.getOldAddressStreet1());
		patientRegistryChangeDto.setOldAddressStreet2(patientRegistryChange.getOldAddressStreet2());
		patientRegistryChangeDto.setOldAddressCity(patientRegistryChange.getOldAddressCity());
		patientRegistryChangeDto.setOldAddressPostalCode(patientRegistryChange.getOldAddressPostalCode());
		patientRegistryChangeDto.setOldAddressState(patientRegistryChange.getOldAddressState());
		patientRegistryChangeDto.setOldAddressProvince(patientRegistryChange.getOldAddressProvince());
		patientRegistryChangeDto.setOldAddressCountry(patientRegistryChange.getOldAddressCountry());
		patientRegistryChangeDto.setOldContactInfoHomePhone(patientRegistryChange.getOldContactInfoHomePhone());

		return patientRegistryChangeDto;
	}


	public PatientRegistryChange convertDTOPatientRegistryChange(PatientRegistryChangeDTO patientRegistryChangeDto) {
		PatientRegistryChange patientRegistryChange = new PatientRegistryChange();

		patientRegistryChange.setId(patientRegistryChangeDto.getId());
		patientRegistryChange.setOplock(patientRegistryChangeDto.getOplock());
		patientRegistryChange.setOldFacilityCount(patientRegistryChangeDto.getOldFacilityCount());
		patientRegistryChange.setOldIcn(patientRegistryChangeDto.getOldIcn());
		///TODO: Fix this - add PATIENT_REGISTRY_CHANGE
		//Add patientId to patientRegistryChange

		patientRegistryChange.setPatientId(patientRegistryChangeDto.getPatientId());

		/*
		if (null != patientRegistryChangeDto.getPatient()) {
			patientRegistryChange.setPatient(patientConverter.convertDTOProfile(patientRegistryChangeDto.getPatient()));
		}
		*/

		patientRegistryChange.setRecordedOnDate(patientRegistryChangeDto.getRecordedOnDate());
		patientRegistryChange.setOldFirstName(patientRegistryChangeDto.getOldFirstName());
		patientRegistryChange.setOldBirthDate(patientRegistryChangeDto.getOldBirthDate());
		patientRegistryChange.setOldIcn(patientRegistryChangeDto.getOldIcn());
		patientRegistryChange.setOldGender(patientRegistryChangeDto.getOldGender());
		patientRegistryChange.setOldMiddleName(patientRegistryChangeDto.getOldMiddleName());
		patientRegistryChange.setOldNamePrefix(patientRegistryChangeDto.getOldNamePrefix());
		patientRegistryChange.setOldNameSuffix(patientRegistryChangeDto.getOldNameSuffix());
		patientRegistryChange.setOldAddressStreet1(patientRegistryChangeDto.getOldAddressStreet1());
		patientRegistryChange.setOldAddressStreet2(patientRegistryChangeDto.getOldAddressStreet2());
		patientRegistryChange.setOldAddressCity(patientRegistryChangeDto.getOldAddressCity());
		patientRegistryChange.setOldAddressPostalCode(patientRegistryChangeDto.getOldAddressPostalCode());
		patientRegistryChange.setOldAddressState(patientRegistryChangeDto.getOldAddressState());
		patientRegistryChange.setOldAddressProvince(patientRegistryChangeDto.getOldAddressProvince());
		patientRegistryChange.setOldAddressCountry(patientRegistryChangeDto.getOldAddressCountry());
		patientRegistryChange.setOldContactInfoHomePhone(patientRegistryChangeDto.getOldContactInfoHomePhone());

		return patientRegistryChange;
	}
}
