package gov.va.med.mhv.admin.service.impl.calendar;

import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import gov.va.med.mhv.admin.converter.VisnConverter;
import gov.va.med.mhv.admin.dto.VisnDTO;
import gov.va.med.mhv.admin.model.Visn;
import gov.va.med.mhv.admin.repository.VisnRepository;
import gov.va.med.mhv.admin.service.calendar.VisnService;
import gov.va.med.mhv.common.api.exception.MHVException;

@Path("/")
@Service("visnService")
@Component
public class VisnServiceImpl implements VisnService {
	private static Logger log = LogManager.getLogger(VisnServiceImpl.class);

	@Autowired
	private VisnRepository visnRepository;

	@Override
	@GET
	@Produces(MediaType.APPLICATION_JSON)
	@Path("/GetVisnLookupByPostalCode/{postalCode}")
	public String getVisnLookupByPostalCode(@PathParam("postalCode") String postalCode) throws MHVException {
		String visnNumber = "";
		try {
			//visnNumber = visnRepository.getVisnLookupByPostalCode(postalCode);
		} catch (Exception e) {
			log.error("Error in fetching UserCalCatsForView " + e);
			throw new MHVException(e);
		}
		return visnNumber;
	}

	@Override
	public List<VisnDTO> getAllVisns() throws MHVException {
		List<VisnDTO> visnsDtos= new ArrayList<VisnDTO>();
		try{
			List<Visn> visns=visnRepository.getAllVisns();
			visnsDtos=VisnConverter.convertVisns(visns);
		}catch(Exception e){
			throw new MHVException(e);
		}
		return visnsDtos;
	}
}
